; Source created with Parsic Version 3.x

; at              : 17/08/02 12.53.02


; Project File    : c:\PROGRA~1\PARSIC\SERIALE\RXRS232.PIC

; Project Version : 1.0.46

; Created         : 10/04/02 18.26.00

; Last change     : 17/08/02 12.52.54

	PROCESSOR 16F876

	INCLUDE P16F876.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_OFF & _BODEN_ON & _XT_OSC & _LVP_OFF & _CPD_OFF & _DEBUG_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

UD1_FD	= 32	; located in Bank 0
S3	= 33	; located in Bank 0
UA1RSFLAG	= 34	; located in Bank 0
ADR	= 35	; located in Bank 0
DATEN2	= 36	; located in Bank 0
MF1	= 37	; located in Bank 0
MF1_HI	= 38	; located in Bank 0
S1	= 39	; located in Bank 0
S0	= 40	; located in Bank 0
ZV1	= 41	; located in Bank 0
DATEN1	= 42	; located in Bank 0
S2	= 43	; located in Bank 0
OS1_FD	= 44	; located in Bank 0
OS2_FD	= 45	; located in Bank 0
ZV1_FD	= 46	; located in Bank 0
TR1	= 47	; located in Bank 0
TR1_HI	= 48	; located in Bank 0
UA1INBUF	= 49	; located in Bank 0
UA1INBUF1	= 50	; located in Bank 0
UA1INBUF2	= 51	; located in Bank 0
UA1INBUF3	= 52	; located in Bank 0
UA1INBUF4	= 53	; located in Bank 0
UA1INBUF5	= 54	; located in Bank 0
UA1INBUF6	= 55	; located in Bank 0
RAM	= 56	; located in Bank 0
SYS_WSAV	= 115	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 116	; located in Bank 0, 1, 2, 3
SYS_PSAV	= 117	; located in Bank 0, 1, 2, 3
SYS_TMP1	= 118	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	MOVLW HIGH SYS_INIT	; set page
	MOVWF PCLATH
	GOTO SYS_INIT

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV
	MOVFW PCLATH
	MOVWF SYS_PSAV
	CLRF PCLATH

;***************************************************
; UART -> UA1
;***************************************************

	BTFSS PIR1,RCIF	; byte received?
	GOTO UA1ENDINT	; no

	MOVFW RCSTA	; error ?
	ANDLW B'110'
	BTFSS STATUS,ZERO
	GOTO UA1RCERROR	; yes

	MOVFW UA1INBUF+1	; all received ? 
	BTFSC STATUS,ZERO	; length =0 ?
	GOTO UA1RCINT2	; yes

	ERRORLEVEL -312
	BANKISEL UA1INBUF
	ERRORLEVEL +312

	MOVFW UA1INBUF
	MOVWF FSR
	INCF UA1INBUF,F	; pointer+1

	MOVFW RCREG	; store
	MOVWF INDF
	ADDWF UA1INBUF+2,F	; checksum
	DECFSZ UA1INBUF+1,F	; length-1
	GOTO EXITINT

	SUBWF UA1INBUF+2,F	; checksum
	BSF UA1RSFLAG,0		; ready
	GOTO EXITINT

UA1RCINT2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW RCREG	; trash
	GOTO EXITINT

UA1RCERROR
	MOVFW RCREG	; reset error status
	BCF RCSTA,CREN
	BSF RCSTA,CREN
	BSF UA1RSFLAG,1	; error
	GOTO EXITINT

;---------------------------------------------------------

UA1ENDINT
	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_0
	INCF MF1_HI,F

SYS_INT_LABEL_0
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_1
	INCF TR1_HI,F

SYS_INT_LABEL_1

EXITINT
	MOVFW SYS_PSAV
	MOVWF PCLATH

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW B'01000000'
	MOVWF PORTC

	MOVLW 15
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG

	MOVLW 6	; all Digital
	MOVWF ADCON1

; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'00000000'
	MOVWF TRISB

	MOVLW B'10011111'
	MOVWF TRISC

; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 16
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'70'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3
	MOVLW 144
	MOVWF FSR
CR4
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR4


;*****************************************
; initalisize UA1
;*****************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'10010000'	; serial enable,8-bit,continous-enable
	MOVWF RCSTA

	BSF STATUS,RP0	; Bank 1
	MOVLW 12
	MOVWF SPBRG	; BAUDRATE GENERATOR
	MOVLW B'00000100'	; 8-BIt,TRANSMIT DISABLED,ASYNCHRON,BRGH=1=HIGH SPEED
	MOVWF TXSTA
	BSF PIE1,RCIE	; enable INTERRUPT for receive

	BSF INTCON,PEIE	; PERIPHERIE INT ENABLE

	BCF STATUS,RP0	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

;***************************************************
; UDATA -> UD1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S3,0	; active
	GOTO LABEL_UD1_1	; yes

; test positive edge

	BTFSS S3,1
	GOTO LABEL_UD1_SETFD
	BTFSC UD1_FD,0
	GOTO LABEL_UD1_SETFD
	BSF UD1_FD,0
	BCF UA1RSFLAG,0	; set nothing received
	BCF UA1RSFLAG,1	; set no error
	BSF S3,0	; active
	MOVLW LOW UA1INBUF+3	; set pointer (adress)
	MOVWF UA1INBUF
	MOVLW H'AA'	; init checksum
	MOVWF UA1INBUF+2
	MOVLW 4	; 4 bytes
	MOVWF UA1INBUF+1
	GOTO LABEL_UD1_SETFD
LABEL_UD1_1
	BTFSC UA1RSFLAG,1	; error ?
	GOTO LABEL_UD1_3	; break
	BTFSS UA1RSFLAG,0	; received ?
	GOTO LABEL_UD1_2	; no

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW UA1INBUF+2	; checksum
	SUBWF UA1INBUF+6,W	; checksum
	BTFSS STATUS,ZERO
	GOTO LABEL_UD1_3	; break
	BCF INTCON,GIE	; disable interrupts
	BTFSC INTCON,GIE	; disabled ?
	GOTO $-2	; no
	MOVFW UA1INBUF+3
	MOVWF ADR
	MOVFW UA1INBUF+4
	MOVWF DATEN1
	MOVFW UA1INBUF+5
	MOVWF DATEN2
	BSF INTCON,GIE	; enable interrupts
LABEL_UD1_3
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,0	; not active
LABEL_UD1_2

LABEL_UD1_SETFD

; test negative edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S3,1
	GOTO LABEL_UD1_EXIT
	BCF UD1_FD,0

LABEL_UD1_EXIT

;***************************************************
; Anzug-Verzgerung -> MF1
;***************************************************

	BTFSS S3,0	; Eingang auf Low ?
	GOTO LABEL_MF1_CHKTIME	; Ja

; RESET

	CLRF MF1
	CLRF MF1_HI
	BCF S3,1
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S3,1	; Ausgang schon auf High ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 0
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 78
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BSF S3,1
LABEL_MF1_EXIT

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 14
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF ADR,W	; F - W -> W

LABEL_IF1_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S3,2
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S3,2

LABEL_IF1_EXIT
;***************************************************
; Multiplexer -> MX1
;***************************************************

	CLRF SYS_TMP1
	MOVFW S0
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL1

	MOVFW S1
	MOVWF S1
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL1
	INCF SYS_TMP1,F
	MOVFW S0
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL2

	MOVFW DATEN1
	MOVWF S1
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL2

LABEL_MX1_END

;***************************************************
; Verteiler -> BV1
;***************************************************

	MOVLW 0 
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S3,2	; IN0
	IORLW 1
	MOVWF S0	; OUT

;***************************************************
; Multiplexer -> MX2
;***************************************************

	CLRF SYS_TMP1
	MOVFW S0
	BTFSS STATUS,ZERO
	GOTO LABEL_MX2_CHECKCONTROL1

	MOVFW ZV1
	MOVWF ZV1
	GOTO LABEL_MX2_END

LABEL_MX2_CHECKCONTROL1
	INCF SYS_TMP1,F
	MOVFW S0
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX2_CHECKCONTROL2

	MOVFW DATEN2
	MOVWF ZV1
	GOTO LABEL_MX2_END

LABEL_MX2_CHECKCONTROL2

LABEL_MX2_END

;***************************************************
; Verteiler -> BV2
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S1,0
	GOTO LABEL_BV2_0
	BCF PORTB,0
	GOTO LABEL_BV2_0_END
LABEL_BV2_0
	BSF PORTB,0
LABEL_BV2_0_END

;**********************************************

	BTFSC S1,1
	GOTO LABEL_BV2_1
	BCF PORTB,1
	GOTO LABEL_BV2_1_END
LABEL_BV2_1
	BSF PORTB,1
LABEL_BV2_1_END

;**********************************************

	BTFSC S1,2
	GOTO LABEL_BV2_2
	BCF PORTB,2
	GOTO LABEL_BV2_2_END
LABEL_BV2_2
	BSF PORTB,2
LABEL_BV2_2_END

;**********************************************

	BTFSC S1,3
	GOTO LABEL_BV2_3
	BCF PORTB,3
	GOTO LABEL_BV2_3_END
LABEL_BV2_3
	BSF PORTB,3
LABEL_BV2_3_END

;**********************************************

	BTFSC S1,4
	GOTO LABEL_BV2_4
	BCF PORTB,4
	GOTO LABEL_BV2_4_END
LABEL_BV2_4
	BSF PORTB,4
LABEL_BV2_4_END

;**********************************************

	BTFSC S1,5
	GOTO LABEL_BV2_5
	BCF PORTB,5
	GOTO LABEL_BV2_5_END
LABEL_BV2_5
	BSF PORTB,5
LABEL_BV2_5_END

;**********************************************

	BTFSC S1,6
	GOTO LABEL_BV2_6
	BCF PORTB,6
	GOTO LABEL_BV2_6_END
LABEL_BV2_6
	BSF PORTB,6
LABEL_BV2_6_END

;**********************************************

	BTFSC S1,7
	GOTO LABEL_BV2_7
	BCF PORTB,7
	GOTO LABEL_BV2_7_END
LABEL_BV2_7
	BSF PORTB,7
LABEL_BV2_7_END

;**********************************************


;***************************************************
; Multiplexer -> MX3
;***************************************************

	CLRF SYS_TMP1
	MOVFW S2
	BTFSS STATUS,ZERO
	GOTO LABEL_MX3_CHECKCONTROL1

	MOVFW ADR
	MOVWF ADR
	GOTO LABEL_MX3_END

LABEL_MX3_CHECKCONTROL1
	INCF SYS_TMP1,F
	MOVFW S2
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX3_CHECKCONTROL2

	MOVLW 0
	MOVWF ADR
	GOTO LABEL_MX3_END

LABEL_MX3_CHECKCONTROL2

LABEL_MX3_END

;***************************************************
; Verteiler -> BV3
;***************************************************

	MOVLW 0 
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S3,3	; IN0
	IORLW 1
	MOVWF S2	; OUT

;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSC S3,4
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S3,3
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,3
	BTFSS S3,4
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; One Shot -> OS2
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S3,2
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S3,4
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,4
	BTFSC S3,2
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************
; Zhler -> ZV1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S3,6	; Reset ?
	GOTO LABEL_ZV1_COUNT
	CLRF ZV1
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S3,5
	GOTO LABEL_ZV1_SETFD
	BTFSC ZV1_FD,0
	GOTO LABEL_ZV1_SETFD

	BSF ZV1_FD,0


	BTFSC S3,6	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV1_BACKWARD

	INCF ZV1,F
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_BACKWARD
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	DECF ZV1,F

LABEL_ZV1_SETOUT


LABEL_ZV1_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S3,5
	GOTO LABEL_ZV1_EXIT
	BCF ZV1_FD,0

LABEL_ZV1_EXIT

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 15	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 66
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 15	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 66
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S3,5
	GOTO LABEL_TR1_CLR
	BSF S3,5
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S3,5
LABEL_TR1_ENDE

;***************************************************
; GND
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,6	; immer Low

;****************************************

	GOTO MAIN


	END

